/*
 *  TOPPERS/FMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Flexible MultiProcessor Kernel
 *
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2006-2012 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  @(#) $Id: chip_support.S 955 2012-10-30 07:31:22Z ertl-honda $
 */

/*
 *  åȰ¸⥸塼 ֥ARMѡ
 */

#define  TOPPERS_MACRO_ONLY
#define UINT_C(val)		(val)		/* uint_tޥ */
#define ULONG_C(val)	(val)		/* ulong_tޥ */
#include "kernel_impl.h"
#include "target_asm.inc"
#include "target_ipi.h"
#include "offset.h"

/*
 *  ٥Υåȥƥ¸ν
 *
 *  ȥåץ⥸塼ǡ˸ƤӽФ롥
 */
    ATEXT
    AALIGN(2)
    AGLOBAL(hardware_init_hook)
ALABEL(hardware_init_hook)
#ifdef TOPPERS_ENA_PERF
    stmfd   sp!, {lr}
    bl      perf_boot_init
    ldmfd   sp!, {lr}
#endif /* TOPPERS_ENA_PERF */
    bx  lr

/*
 * ߥϥɥ
 */
    ATEXT
    AALIGN(2)
    AGLOBAL(irq_handler)
ALABEL(irq_handler)
    /*
     * IRQ⡼ɤǼ¹Ԥ
     */
    sub   lr, lr, #4 /* 襢ɥ쥹  */

    /*
     * lr() spsr(cpsr_svc)򥹡ѡХ⡼ɤΥå
     * ¸
     */
    srsdb #CPSR_SVC!

    /*
     *  Υ⡼(ѡХ⡼)
     *  ܹԤƥȤ¸
     */
    msr   cpsr_cxsf, #(CPSR_SVC AOR CPSR_CPULOCK AOR CPSR_ALWAYS_SET)
    stmfd sp!, {r0-r3,ip,lr}

    /*
     *  PCBμ
     */
    my_pcb r0, r3

#if TTYPE_KLOCK != G_KLOCK
    /*
     *  ץåγ٥åξϥåƤ뤫å
     *  ƤХå롥
     */
ALABEL(release_lock)
    ldr   r3, [r0, #PCB_p_firstlock]  /* p_firstlock  */
    cmp   r3, #0                      /* NULLʤ齪λ       */
    beq   release_lock_end
    mov   r2, #0
    mcr   p15, 0, r2, c7, c10, 5      /* data_memory_barrier */
    str   r2, [r3]
    mcr   p15, 0, r2, c7, c10, 4      /* data_sync_barrier */
    sev
    str   r2, [r0, #PCB_p_firstlock]  /* p_firstlock  NULL  */
    ldr   r3, [r0, #PCB_p_secondlock] /* p_secondlock  */
    cmp   r3, #0                      /* NULLʤ齪λ       */
    mcr   p15, 0, r2, c7, c10, 5      /* data_memory_barrier */
    str   r2, [r3]
    mcr   p15, 0, r2, c7, c10, 4      /* data_sync_barrier */
    sev
    str   r2, [r0, #PCB_p_firstlock]  /* p_secondlock  NULL  */
ALABEL(release_lock_end)
#endif /* TTYPE_KLOCK != G_KLOCK */

    mov   lr, sp         /* λΥåΤ */

    /*
     *  װȽꡥ
     */
    ldr   r2, =(DIC_CPUIF_IAR)
    ldr   r12, [r2]
    mov   r1, r12, lsl #22  /* 10ӥåȰʳ򥯥ꥢ */
    mov   r1, r1,  lsr #22

   /*
    *  spurious(INT_ID=1023(0x03ff))ξ硤߽λ
    */
   ldr   r2, =(0x03ff)
   cmp   r2, r1
   beq   ret_int_2

#ifdef TOPPERS_SAFEG_SECURE
   /*
    *  TrustZoneѤȤϡINT_ID=1022(0x03fe)
    *  spuriousߤȤʤ롥
    */
   ldr   r2, =(0x03fe)
   cmp   r2, r1
   beq   ret_int_2
#endif /* TOPPERS_SAFEG_SECURE */

#ifdef USE_IPI_DIS_HANDER_BYPASS
    cmp     r1, #IPINO_DIS
    ldreq   r2,=DIC_CPUIF_EOI
    streq   r12,[r2]                /* EOI쥸ؤν񤭹 */
    beq     ret_int_ipi_dispatch
#endif /* USE_IPI_DIS_HANDER_BYPASS */

    /*
     *  ¿ųߤȽ
     */
    ldr   r3, [r0, #PCB_excpt_nest_count]  /* 㳰ߥͥȲ */
    add   r2, r3, #1                       /* 㳰ߥͥȲ򹹿 */
    str   r2, [r0, #PCB_excpt_nest_count]
    cmp   r3, #0
    bne   irq_handler_1

    /*
     * ܤ㳰ʳߡˤʤ饹åѹ
     */
    ldr   sp, [r0, #PCB_istkpt]

ALABEL(irq_handler_1)
    stmfd sp!, {lr}     /* ѤΥåݥ󥿤¸ */

    /*
     *  ߥϥɥΥɥ쥹
     */
    ldr   r3, [r0, #PCB_p_inh_tbl]   /* ߥϥɥơ֥ɤ߹ */
    ldr   r0, [r3, r1, lsl #2]       /* r0<-ߥϥɥ */

    /*
     *  װγͥ٤(ǥ)ͥ٥ޥ򥻥å
     *  롥ޤκݡϥɥ¹(ǥ)ͥ٥ޥ
     *  ¸롥
     */
    ldr   lr, =(DIC_CPUIF_RII)
    ldr   r2, [lr]
    ldr   r3, =(DIC_CPUIF_PMR) /* ȯγͥ٥ޥ */
    ldr   lr, [r3]
    str   r2, [r3]   /* ͥ٥ޥ򥻥åȤ */
    stmfd sp!, {lr}  /* ȯγͥ٥ޥ򥹥å¸ */

    stmfd sp!,{r12}      /* DIC_CPUIF_IAR Ƥ¸  */
    stmfd sp!,{r1}       /* inhno ¸  */

    /*
     * ߵ
     */
    msr   cpsr_cxsf, #(CPSR_SVC AOR CPSR_ALWAYS_SET)

#ifdef LOG_INH_ENTER
    stmfd sp!,{r0}
    mov   r0, r1         /* inhno ѥ᡼    */
    bl    log_inh_enter  /* log_inh_enterƤӽФ */
    ldmfd sp!,{r0}
#endif /* LOG_INH_ENTER */

    /*
     * ߥϥɥθƤӽФ
     */
    mov   lr,  pc
    bx    r0

ALABEL(target_ret_int)

    ldmfd sp!,{r0}       /* inhno   */
    ldmfd sp!,{r12}      /* DIC_CPUIF_IAR Ƥ¸  */

    ldr   r1,=DIC_CPUIF_EOI
    str   r12,[r1]               /* EOI쥸ؤν񤭹 */

#ifdef LOG_INH_LEAVE
    bl    log_inh_leave  /* log_inh_leaveƤӽФ */
#endif /* LOG_INH_LEAVE */

    /*
     * ͥγߤػߤ
     */
    msr   cpsr_cxsf, #(CPSR_SVC AOR CPSR_CPULOCK AOR CPSR_ALWAYS_SET)

    /*
     * ͥ٥ޥ򸵤᤹
     */
    ldmfd sp!,{r1}                       /* γͥ٥ޥ */
    ldr   r0, =(DIC_CPUIF_PMR)           /* DIC˥å */
    str   r1, [r0]

    /*
     * åݥ󥿤
     */
    ldmfd sp!,{r2}              /* Υåݥ󥿤 */
    mov   sp, r2

    /*
     * νARM¸Ǽ¹
     */
    b     ret_int


/*
 * åȰ¸㳰
 * ARMv6/7ARMv4ȸƤӽФ郎ۤʤ뤿դ뤳ȡ
 * ѡХ⡼ɤǸƤӽФ롥
 */
    ATEXT
    AGLOBAL(target_exc_handler)
ALABEL(target_exc_handler)
    mov   lr, sp         /* λΥåΤ */

    ldr   r0, =(DIC_CPUIF_PMR) /* 㳰ȯγͥ٥ޥ */
    ldr   r3, [r0]
    asr   r3, r3, #DIC_CPUIF_PMR_OFFSET /* ɽѹ */
    sub   r3, r3, #(IPM_BIT_MASK)
    stmfd sp!, {r3}  /* 㳰ȯγͥ٥ޥ򥹥å¸ */

    /*
     *  ƥȽΤᡤexcpt_nest_count 򥹥å¸
     *  å¸ߤexcpt_nest_count-1ȼǤ뤬
     *  åѤǤǥХåԤ䤹Τǡå
     *  ¸롥
     */
    my_pcb r0, r3
    ldr   r3, [r0, #PCB_excpt_nest_count]
    stmfd sp!, {r3}

    mov   r3,  sp         /* 㳰ե졼Ϥ¸ */

    /*
     * ͥCPU㳰Ƚꤹ
     *
     * ͥCPU㳰ϡͥ¹桤ߥå֡
     * CPUå֡ͥγߥϥɥ¹ȯ
     * CPU㳰Ǥ롥ARMξϡSPSRI/Fե饰Τ줫'1'ʤ顤
     * 롥
     */
    ldr   r1, [sp, #(9*4)]              /* 㳰ե졼फspsr */
    tst   r1, #(CPSR_FIQ_BIT AOR CPSR_IRQ_BIT)
    bne   target_kernel_unc_exc_handler /* ͥCPU㳰ν */

    /*
     *  㳰ȯΥƥȤȽ
     */
    ldr   r1, [r0, #PCB_excpt_nest_count]
    add   r1, r1, #1
    str   r1, [r0, #PCB_excpt_nest_count]
    cmp   r1, #1
    bne   target_exc_handler_1

    /*
     * ƥȤCPU㳰ȯ
     * å󥿥ƥȤڤؤ롥
     */
    ldr   sp, [r0, #PCB_istkpt]

ALABEL(target_exc_handler_1)
    stmfd sp!, {lr}     /* ѤΥåݥ󥿤¸ */

    /*
     *  locspnid¸
     */
    my_pcb r0, r1
    ldr    r1, [r0,#PCB_locspnid]
    stmfd  sp!,{r1}

    /*
     * ȯγͥ٥ޥ򥹥å¸
     * ߥϥɥȽи롼ͭ뤿¸
     */
    ldr   r12, =(DIC_CPUIF_PMR) /* 㳰ȯγͥ٥ޥ */
    ldr   r1, [r12]
    stmfd sp!, {r1}  /* 㳰ȯγͥ٥ޥ򥹥å¸ */

    /*
     *  CPU㳰ϥɥεưϤ
     */
    ldr   r12, [r0, #PCB_p_exch_tbl]  /* ߥϥɥơ֥ɤ߽Ф */
    ldr   r1, [r12, r2, lsl #2]       /* r1<-㳰ϥɥ                 */

    stmfd sp!,{r2}      /* excno ¸ */

    /*
     * ߵ
     * CPU㳰ϥɥ̥롼ǸƤӽФᡤñSVC⡼
     * ˤǤ褤
     */
    msr   cpsr_cxsf, #(CPSR_SVC AOR CPSR_ALWAYS_SET)

#ifdef LOG_EXC_ENTER
    stmfd sp!,{r1, r3}
    mov   r0, r2         /* excno ѥ᡼    */
    bl    log_exc_enter  /* log_exc_enterƤӽФ */
    ldmfd sp!,{r1, r3}
#endif /* LOG_EXC_ENTER */

    /*
     * CPU㳰ϥɥθƤӽФ
     *
     * 㳰ե졼ƬȤϤ
     */
    mov   r0,  r3
    mov   lr,  pc
    bx    r1

ALABEL(target_ret_exc)
    ldmfd sp!,{r0}       /* excno   */
#ifdef LOG_EXC_LEAVE
    bl    log_exc_leave  /* log_exc_leaveƤӽФ */
#endif /* LOG_EXC_LEAVE */

    /*
     * ͥγߤػߤ
     */
    msr   cpsr_cxsf, #(CPSR_SVC AOR CPSR_CPULOCK AOR CPSR_ALWAYS_SET)

    /*
     * ͥ٥ޥ򸵤᤹
     */
    ldmfd sp!,{r1}                       /* γͥ٥ޥ */
    ldr   r0, =(DIC_CPUIF_PMR)           /* DIC˥å */
    str   r1, [r0]

    /*
     * CPU㳰ȯlocspnidr0
     */
    ldmfd sp!,{r0}

    /*
     * åݥ󥿤
     */
    ldmfd sp!,{r2}              /* Υåݥ󥿤 */
    mov   sp, r2

    /*
     * νARM¸Ǽ¹
     */
    b     ret_exc


/*
 * ͥCPU㳰ν
 */
ALABEL(target_kernel_unc_exc_handler)
    /*
     * ȯΥƥȤȽ
     */
    ldr   r1, [r0, #PCB_excpt_nest_count]
    add   r1, r1, #1
    str   r1, [r0, #PCB_excpt_nest_count]
    cmp   r1, #1
    bne   target_kernel_unc_exc_handler_1

    /*
     * ƥȤCPU㳰ȯ
     * å󥿥ƥȤڤؤ롥
     */
    ldr   sp, [r0, #PCB_istkpt]

ALABEL(target_kernel_unc_exc_handler_1)
    stmfd sp!, {lr}     /* ѤΥåݥ󥿤¸ */

    /*
     *  CPU㳰ϥɥεưϤ
     */
    ldr   r1, [r0, #PCB_p_exch_tbl]   /* ߥϥɥơ֥ɤ߽Ф */
    ldr   r1, [r1, r2, lsl #2]        /* r1<-㳰ϥɥ                 */

   /*
    * ƥ֡ʥƥȤϽˤCPU㳰ȯξ֤
    */
    ldr   r0, [r3, #(9*4)]     /* CPU㳰ȯCPSRμ */
    and   r0, r0, #(CPSR_IRQ_BIT AOR CPSR_FIQ_BIT)
    orr   r0, r0, #(CPSR_SVC AOR CPSR_ALWAYS_SET)
    msr   cpsr_cxsf, r0

    /*
     * CPU㳰ϥɥθƤӽФ
     * 㳰ե졼ƬȤϤ
     */
    mov   r0, r3
    mov   lr, pc
    bx    r1

    /*
     *  㳰ߤΥͥȥȡexcpt_nest_count)Υǥ
     */
    my_pcb r0, r3
    ldr   r1, [r0, #PCB_excpt_nest_count]
    sub   r1, r1, #1
    str   r1, [r0, #PCB_excpt_nest_count]

    /*
     * åݥ󥿤
     */
    ldmfd sp!, {r2}             /* Υåݥ󥿤 */
    mov   sp, r2

    /*
     * CPU㳰
     */
    ldmfd sp!,{r0-r3,ip,lr}
    rfeia sp!
